package org.apache.commons.lang3;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Set;
import org.apache.commons.lang3.ClassUtils;

final class null implements Iterator<Class<?>> {
  Iterator interfaces = Collections.emptySet().iterator();
  
  public boolean hasNext() {
    return (this.interfaces.hasNext() || wrapped.hasNext());
  }
  
  public Class<?> next() {
    if (this.interfaces.hasNext()) {
      Class<?> nextInterface = this.interfaces.next();
      seenInterfaces.add(nextInterface);
      return nextInterface;
    } 
    Class<?> nextSuperclass = wrapped.next();
    Set<Class<?>> currentInterfaces = new LinkedHashSet();
    walkInterfaces(currentInterfaces, nextSuperclass);
    this.interfaces = currentInterfaces.iterator();
    return nextSuperclass;
  }
  
  private void walkInterfaces(Set<Class<?>> addTo, Class c) {
    for (Class<?> iface : c.getInterfaces()) {
      if (!seenInterfaces.contains(iface))
        addTo.add(iface); 
      walkInterfaces(addTo, iface);
    } 
  }
  
  public void remove() {
    throw new UnsupportedOperationException();
  }
}
